/* --------------------------------------------------------------------------------------------
 *  EL-POINT subset version for KARIHITO
 *  music creative driver for Win32 Netscape Plug-in
 *  (C) 1999,2000 Ƃ悵
 * --------------------------------------------------------------------------------------------
 *  [GraphicBuffer.h]
 *   DIB߂̃NXB摜t@Cǂݍ݌Œ`DIBɕϊAi[B
 *  DIB̃tH[}bǵA32bitRGBŁAPsNZ4oCgAォ珇ɐE΁EԁEgpB
 *  ColorKeyBlendgāAʂGraphicBuffer̉摜ƍ\B܂AGDIAPIɂ͔fȂ
 *  Iɂ͖gpoCg`lƂĎgpĂBGraphicBufferԂ̍ɂ͗LB
 * -------------------------------------------------------------------------------------------- */

#if !defined(__GraphicBuffer_h__)
#define	__GraphicBuffer_h__

#if !defined(__Common_h__)
#	include "Common.h"
#endif	// !defined(__Common_h__)

#if !defined(__GraphicText_h__)
#	include "GraphicText.h"
#endif	// !defined(__GraphicText_h__)

#if !defined(__GraphicTextGDI_h__)
#	include "GraphicTextGDI.h"
#endif	// !defined(__GraphicTextGDI_h__)

class GraphicBuffer: public GraphicTextGDI, public GraphicText{
#define	CGB_TRANS_SRCCOPY	0
#define	CGB_TRANS_COLORKEY	1
#define	CGB_TRANS_ALPHADATA	2
private:
	static int nInstance;
	static HDC hDc;
	BITMAPINFOHEADER bmih;
	HBITMAP hBitmap;
	unsigned long width;
	unsigned long height;
	char *bits;
	int *reference;
	unsigned long key;
	int transmode;
	GraphicBuffer *alpha;
public:
	GraphicBuffer(void);
	GraphicBuffer(GraphicBuffer &src);
	GraphicBuffer(GraphicBuffer *src);
	~GraphicBuffer(void);
	int LoadImage(const char *filename);
	int ResourceImage(LPCTSTR resourcename, int width, int height, HINSTANCE hInstance = NULL);
	int MakeImage(unsigned long width, unsigned long height);
	bool GetData(unsigned long &width, unsigned long &height, char *&bits) const;
	const LPBITMAPINFO GetLpBitsInfo(void) const;

	// 
	bool ColorKeyBackBlend(GraphicBuffer *back, int x = 0, int y = 0);
	bool ColorKeyBackBlend(GraphicBuffer *back, int r, int g, int b, int x = 0, int y = 0);
	bool ColorKeyOverBlend(GraphicBuffer *over, int x = 0, int y = 0);
	bool Blt(GraphicBuffer *src, int x = 0, int y = 0);
	bool BltToBuffer(GraphicBuffer *buf, int buf_x = 0, int buf_y = 0, int src_x = 0, int src_y = 0, int src_w = -1, int src_h = -1);
	void SetTransColor(int r, int g, int b);
	void SetTransColor(unsigned long rgb);
	bool GetTransColor(unsigned long &colorkey);
	void ResetTransColor(void);
	int GetTransMode(void);
	bool SetAlphaData(GraphicBuffer *alpha);

	// (GraphicTextNX)
	bool SetTextFont(int size, int width, int height, int r, int g, int b);
	bool SetTextBkColor(int r, int g, int b);
	bool DrawText(int x, int y, int code);
	bool DrawString(int x, int y, char *string);

	// `揈
	void FillRect(int sx, int sy, int ex, int ey, unsigned long color);
private:
	HBITMAP CreateDIB(unsigned long width, unsigned long height);
	int LoadBitmap(const char *buffer, unsigned long size);
};

#if !defined(__GraphicBuffer__)
#	define	__GraphicBuffer__
#endif	// !defined(__GraphicBuffer__)

#endif	// !defined(__GraphicBuffer_h__)
